import java.io.*;
import java.util.*;
class Lire
{
    static Vector V;

    // Lecture a partir du Clavier.
    static String Taper(String s)   throws IOException
    {
        InputStreamReader entrer = new  InputStreamReader(System.in);
        BufferedReader valider = new  BufferedReader(entrer);
        String str;
        do {
         System.out.print(s);
        str = valider.readLine();
        } while (str.equals(""));
         return str;
    }

    // Comparaison de chanes de caractres
    static int comparer (String s1, String s2)
    { return s1.compareTo(s2); }

    // Fonction Impression du Vecteur
    static void impression(Vector V,int n1, int n2)
    {
	for (int i = n1; i < n2; ++i)
	    {
		ens X= (ens)V.elementAt(i);
		X.afficher();
	    }
    }

    //  Fonction Transposer les Donnes
    static void transposer (Vector V, int i, int j)
    {
	ens X= (ens)V.elementAt(i);
	ens Y= (ens)V.elementAt(j);
	V.set(j,X);
	V.set(i,Y);
    }

    // Fonction Lower (Maj en Min
    static String  lower(String s1)
    {
        String s2="";
	for (int i=0; i<s1.length(); i++)
            s2=s1.toLowerCase();// pour convertir en miniscule
        return s2;
    }

    // Fonction Inserer dans le Vecteur
    static void inserer(String s,Vector T)
    {
	ens X= new ens(s);
	for (int i=0 ; i < T.size() ; i++)
	    {
		ens w= (ens) T.elementAt(i);
		int r = X.nom.compareTo(w.nom);
		if (r == 0)   // Dj dans le Vecteur
		    {
			w.nb++;
			T.set(i,w);
			return;
		    }
	    }
	T.addElement(X); // insrer en fin du Vecteur
    }

    // Fonction QuickSort
    static void QSort(Vector V, int g, int d)
    {
	int i, m, x, v;
	ens X,Y;
	if (g < d) {
	    X = (ens) V.elementAt(g);
	    m = g;
	    for (i = g+1; i <= d; ++i)
		{
		    Y =(ens) V.elementAt(i);
		    if(comparer(Y.nom,X.nom)<0) {
			++m;
			transposer(V,m,i);
		    }
		}
	    transposer(V,m,g);
	    QSort (V,g, m-1);
	    QSort (V,m+1, d);
	}
    }

    //  Fonction Recherche Dichotomique
    static int RecDic(String s,Vector V, int g, int d)
    {
    if (g>d) return -1;
    else {
            int mi = (g+d)/2;
            ens X = (ens) V.elementAt(mi);
            if (comparer(s,X.nom) == 0) return mi;
            if (comparer(s,X.nom) < 0) return RecDic(s,V,g,(mi-1));
            return RecDic(s,V,(mi+1),d);
            }
    }

    // Fonction Recherche
    static void rechMot(Vector V, String mot1,String mot2, String motX, int g, int d)
    {
	int x1=RecDic(mot1,V,g,d);
                 int x2=RecDic(mot2,V,g,d);

	int max ,min;
                  if (x1>x2) { max=x1; min=x2;}
                  else { max=x2; min=x1;}
                  while ((x1 != -1) && (x2 != -1))
                   {
                      int x3=RecDic(motX,V,min,max);
                      if (x3 == -1)  System.out.println(">> "+motX+"  n'xiste pas");
                      else {
                               ens X = (ens) V.elementAt(x3);
                               X.afficher();
                               }
                      return;
                   }
                   System.out.println("Intervalle incorcte");
                   return;
       }

    /* Fonction Lire */
    public static void lire(String fic) throws Exception
    {
	FileReader fichier = new FileReader(fic);
	StreamTokenizer mot = new StreamTokenizer(fichier);
	V = new Vector();
	String S;
	mot.resetSyntax();
	mot.parseNumbers();
	mot.whitespaceChars(0,' ');
	mot.wordChars('A','Z');
	mot.wordChars('a','z');
	// Parcour du fichier donne en argument avec arg[0]
	while ( mot.nextToken()!= mot.TT_EOF)
	    if (mot.ttype == StreamTokenizer.TT_WORD)
		{
		    S=lower(mot.sval);
		    inserer(S,V);
		}
	fichier.close();
    } // ------------------------

    static  void triSimple(Vector V, int deb, int fin) {
	for(int i=1;i<V.size();i++) {
	    int j=i;
	    ens  tmp=(ens) V.elementAt(i);
	    ens  X=(ens) V.elementAt(j-1);
	    while((j>0) && (comparer(X.nom,tmp.nom)>0) ){
		V.set(j,X);
		//a[j]=a[j-1];
		X=(ens) V.elementAt(j--);
		//j--;
	    } 
	    V.set(j,tmp);
	    //a[j]=tmp;   
	}
    }

    static void triSelection(Vector V, int deb, int fin) {
        ens max,tmp1,tmp2;
        int k, j, jmax, n=V.size();
	for( k=n-1; k>0; k--) {
	    // Etape: chercher le max ds le Vecteur
	    jmax=k;
	    max=(ens) V.elementAt(jmax);
	    for(j=0; j<k; j++) {
		tmp1=(ens) V.elementAt(j);
		if(comparer(tmp1.nom,max.nom) > 0) { jmax=j; max=(ens) V.elementAt(jmax); }
	    }
	    // ranger le max: changer max en V.elementAt(jmax)
	    tmp2=(ens) V.elementAt(j);
	    V.set(jmax,tmp2);
	    V.set(k,max);
	}
    }

        
    /* Programme Principale  main */
    static void main(String args [])throws Exception
    {
	if (args.length != 0)
	    {
		lire(args[0]);
		int n=V.size();
		impression(V,0,n);
                System.out.println("--------------------- Le Tri. ");
                System.out.println("<1>  Pour le Tri Rapide ");
                System.out.println("<2>  Pour le Tri Simple ");
                String choix = Taper("Entrer votre choix SVP? :");
                if (choix.equals("1")) {
		System.out.println(" >> --- Le Tri Rapide --- << ");
		QSort(V,0,n-1); }
                else if (choix.equals("2")) {
		System.out.println(" >> --- Le Tri Simple --- << ");
		triSelection(V,0,n);  }
		impression(V,0,n);
                 System.out.println("--------------- La Recherche.");
                String mot1 = Taper("Entrer le premier mot : ");
                String mot2 = Taper("Entrer le second mot : ");
                String motX = Taper("Entrer le mot  rechercher : ");
                 rechMot(V, mot1,mot2, motX, 0, n) ;

	    }
	else System.out.println("Entrez le nom du fichier SVP!");
    }
}
    /* Ma Structure de donnes */
    class ens { 
	String nom;
	int nb;
	public ens()
	{
	    nom="";
	    nb=0;
	}	
	public ens(String s)
	{
	    nom=s;
	    nb=1;
	}
	public  ens(String s,int n)
	{
	    nom = s;
	    nb = n;
	}
	public void afficher()
	{ 
	    System.out.println("Nom : "+nom+" Nb: "+nb);
	}  
    } // ----------------------
    

