import java.io.*;
import java.lang.*;
import java.util.*;

/* Ma Structure de donnes */
class ens {
    String nom;
    int nb;
    public ens()
    {
	nom="";
	nb=0;
    }
    public ens(String s)
    {
	nom=s;
	nb=1;
    }
    public  ens(String s,int n)
    {
	nom = s;
	nb = n;
    }
    public void afficher()
    {
	System.out.println("Nom : "+nom+" Nb: "+nb);
    }
}

class ArbreAVL {
    ens   contenu;
    ArbreAVL    fg;
    ArbreAVL    fd;
    int         bal;

   public ArbreAVL () {
     this.contenu = new ens();
       this.fg = null;
       this.fd = null;
       this.bal=0;
  }

  public ArbreAVL (String s, ArbreAVL a, ArbreAVL b) {
       this.contenu = new ens(s);
       this.fg = a;
      this. fd = b;
  }

  public static ArbreAVL nouvelArbreAVL (String s, ArbreAVL a, ArbreAVL b) {
      return new ArbreAVL (s, a, b);
  }

    public String toString(){
	return this.toString("");
    }
    private String toString(String tab){
	String s = "";
	if(fd != null)
	    s += fd.toString(tab+"\t");
	s += tab + contenu.nom + ":" + contenu.nb + "\n";
	if(fg != null)
	    s += fg.toString(tab+"\t");
	return s;
    }

    static ArbreAVL recherche (String s, ArbreAVL a) {
	//ArbreAVL      r = null;
	if (a == null || s.compareTo(a.contenu.nom) == 0)
	    return a;
	else
	    if (s.compareTo(a.contenu.nom)<0)
		return recherche (s, a.fg);
	    else
		return recherche (s, a.fd);
    }
    // Fonction Lower (Maj en Min
    static String  lower(String s1)
    {
	String s2="";
	for (int i=0; i<s1.length(); i++)
	    s2=s1.toLowerCase();// pour convertir en miniscule
	return s2;
    }
    
    /* Fonction Lire */
    public static void lire(String fic) throws Exception
    {
	FileReader fichier = new FileReader(fic);
	StreamTokenizer mot = new StreamTokenizer(fichier);
	// a = new ArbreAVL();
	String S;
	mot.resetSyntax();
	mot.parseNumbers();
	mot.whitespaceChars(0,' ');
	mot.wordChars('A','Z');
	mot.wordChars('a','z');
	// Parcour du fichier donne en argument avec arg[0]
	while ( mot.nextToken()!= mot.TT_EOF)
	    if (mot.ttype == StreamTokenizer.TT_WORD)
		{
		    S = lower(mot.sval);
		    a = ajouter(S,a);
		}
	fichier.close();
    }
  static  ArbreAVL a;
  public static void main(String args[])  throws Exception{
     if (args.length != 0)
	    {

		lire(args[0]);
		System.out.println (a);
		//imprimerArbre (a);
		System.out.println ("---------------------------------------------------------");
		/* abr = ajouter ("xx", abr);
		   abr = ajouter ("kk", abr);
		   abr = ajouter ("a", abr);
		   imprimerArbre (abr);
		   System.out.println ("La taille de l'arbre : " +taille (abr));
		   System.out.println (" Recherche de aa");
		   imprimerArbre (recherche ("aa", abr));
		   System.out.println (" Recherche de xx");
		   imprimerArbre (recherche ("xx", abr)); */
	    }
	else System.out.println("Entrez le nom du fichier SVP!");
  }

  static class Paire {
    int      champ1;
    ArbreAVL champ2;

    Paire (int r, ArbreAVL a) {
       champ1 = r;
       champ2 = a;
    }
  }

  static ArbreAVL ajouter(String s, ArbreAVL a) {
    return ajouter1( s, a).champ2;
  }

  static Paire ajouter1(String s, ArbreAVL a) {
    int        incr, r;
    Paire      p;
    r = 0;
    if (a == null) {
        a = nouvelArbreAVL (s, null, null);
        a.bal = 0;
        r = 1;
    } else {
       if (s.compareTo(a.contenu.nom) == 0) {  a.contenu.nb++;  incr=0;}
       else if (s.compareTo(a.contenu.nom)<0) {
            p = ajouter1 (s, a.fg);
            incr = -p.champ1;
            a.fg = p.champ2;
       } else {
            p = ajouter1 (s, a.fd);
            incr = p.champ1;
            a.fd = p.champ2;
      }
        a.bal = a.bal + incr;
        if (incr != 0 && a.bal != 0)
            if (a.bal < -1)
                // \esc{La gauche est trop grande} *
                if (a.fg.bal < 0) {

                    a = rotD (a);   }
                else {

                    a.fg = rotG (a.fg);
                    a = rotD (a);
                }
            else
            if (a.bal > 1)
                // \esc{La droite est trop grande}
                if (a.fd.bal > 0)
                    a = rotG (a);
                else {
                    a.fd = rotD (a.fd);
                    a = rotG (a);
                }
            else
               r = 1;
    }
    return new Paire (r, a);
  }

 static ArbreAVL rotD (ArbreAVL a) {
    ArbreAVL  b;
    int       bA, bB, bAnew, bBnew;

    b = a;
    a = a.fg;
    bA = a.bal; bB = b.bal;
    b.fg = a.fd;
    a.fd = b;
    // \esc{\it Recalculer le champ \prog|a.bal|}
    bBnew = 1 + bB - Math.min(0, bA);
    bAnew = 1 + bA + Math.max(0, bBnew);
    a.bal = bAnew;
    b.bal = bBnew;
    return a;
  }

  static ArbreAVL rotG (ArbreAVL a) {
    ArbreAVL  b;
    int       bA, bB, bAnew, bBnew;

    b = a.fd;
    bA = a.bal; bB = b.bal;
    a.fd = b.fg;
    b.fg = a;
    // \esc{\it Recalculer le champ \prog|a.bal|}
    bAnew = bA - 1 - Math.max(0, bB);
    bBnew = bB - 1 + Math.min(0, bAnew);
    a.bal = bAnew;
    b.bal = bBnew;
    return b;
  }
}
